using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Orders;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IOrderRepository
    {
        Task<BaseResult> Add(OrderElastic Order);
        Task<BaseResult> AddManyAsync(IEnumerable<OrderElastic> Orders);
        Task<SmartTableResult<OrderElastic>> Search(BoolQueryDescriptor<OrderElastic> query);
        Task<SmartTableResult<OrderElastic>> Search(BoolQueryDescriptor<OrderElastic> query, int count);
        Task<SmartTableResult<OrderElastic>> GetByIds(List<long> ids);

    }
    public class OrderRepository : IOrderRepository
    {
        private readonly ElasticIndex<OrderElastic> _dbContext;

        public OrderRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<OrderElastic>(settings.Value.ClusterUrl, "inventoryorder");
        }


        public async Task<SmartTableResult<OrderElastic>> Search(BoolQueryDescriptor<OrderElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(OrderElastic Order)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Order);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<OrderElastic> Orders)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Orders);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<OrderElastic>> Search(BoolQueryDescriptor<OrderElastic> query, int count)
        {
            return await _dbContext.Search(query, count);
        }

        public async Task<SmartTableResult<OrderElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<OrderElastic>();
            var idsQ = new QueryContainerDescriptor<OrderElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }
    }
}
